<?php
/**
 * Shopgate GmbH
 *
 * URHEBERRECHTSHINWEIS
 *
 * Dieses Plugin ist urheberrechtlich geschützt. Es darf ausschließlich von Kunden der Shopgate GmbH
 * zum Zwecke der eigenen Kommunikation zwischen dem IT-System des Kunden mit dem IT-System der
 * Shopgate GmbH über www.shopgate.com verwendet werden. Eine darüber hinausgehende Vervielfältigung, Verbreitung,
 * öffentliche Zugänglichmachung, Bearbeitung oder Weitergabe an Dritte ist nur mit unserer vorherigen
 * schriftlichen Zustimmung zulässig. Die Regelungen der §§ 69 d Abs. 2, 3 und 69 e UrhG bleiben hiervon unberührt.
 *
 * COPYRIGHT NOTICE
 *
 * This plugin is the subject of copyright protection. It is only for the use of Shopgate GmbH customers,
 * for the purpose of facilitating communication between the IT system of the customer and the IT system
 * of Shopgate GmbH via www.shopgate.com. Any reproduction, dissemination, public propagation, processing or
 * transfer to third parties is only permitted where we previously consented thereto in writing. The provisions
 * of paragraph 69 d, sub-paragraphs 2, 3 and paragraph 69, sub-paragraph e of the German Copyright Act shall remain unaffected.
 *
 * @author Shopgate GmbH <interfaces@shopgate.com>
 */

class Shopware_Controllers_Frontend_Shopgate extends Enlight_Controller_Action
{
    
    public function indexAction()
    {
        $this->View()->setTemplate();
        echo 'Shopgate Shopware-Schnittstelle::Sie m&uuml;ssen die API-Action aufrufen, um das Framework zu starten!';
    }
    
    public function pingAction()
    {
        $_REQUEST['action'] = 'ping';
        $this->apiAction();
    }
    
    public function cronAction()
    {
        $_REQUEST['action'] = 'cron';
        $this->apiAction();
    }
    
    public function addOrderAction()
    {
        $_REQUEST['action'] = 'add_order';
        $this->apiAction();
    }
    
    public function updateOrderAction()
    {
        $_REQUEST['action'] = 'update_order';
        $this->apiAction();
    }
    
    public function getCustomerAction()
    {
        $_REQUEST['action'] = 'get_customer';
        $this->apiAction();
    }
    
    public function getItemsCsvAction()
    {
        $_REQUEST['action'] = 'get_items_csv';
        $this->apiAction();
    }
    
    public function getCategoriesCsvAction()
    {
        $_REQUEST['action'] = 'get_categories_csv';
        $this->apiAction();
    }
    
    public function getReviewsCsvAction()
    {
        $_REQUEST['action'] = 'get_reviews_csv';
        $this->apiAction();
    }
    
    public function getPagesCsvAction()
    {
        $_REQUEST['action'] = 'get_pages_csv';
        $this->apiAction();
    }
    
    public function getLogFileAction()
    {
        $_REQUEST['action'] = 'get_log_file';
        $this->apiAction();
    }
    
    public function clearLogFileAction()
    {
        $_REQUEST['action'] = 'clear_log_file';
        $this->apiAction();
    }
    
    public function clearCacheAction()
    {
        $_REQUEST['action'] = 'clear_cache';
        $this->apiAction();
    }
    
    public function checkCartAction()
    {
        $_REQUEST['action'] = 'check_cart';
        $this->apiAction();
    }
    
    public function redeemCouponsAction()
    {
        $_REQUEST['action'] = 'redeem_coupons';
        $this->apiAction();
    }
    
    public function getSettingsAction()
    {
        $_REQUEST['action'] = 'get_settings';
        $this->apiAction();
    }
    
    public function apiAction()
    {
        define("_SHOPGATE_API", true);
        
        $this->View()->setTemplate();
        
        /*** Shopinformation / Pluginconfiguration ***/
        $shop   = Shopware()->Shop()->getId();
        $locale = Shopware()->Locale()->getId();
        
        if (empty($shop) || empty($locale)) {
            throw new Enlight_Exception('Plugin-Fehler! Shop oder Locale-ID leer!');
        }
        
        $plugin = new ShopgatePluginShopware();
        $plugin->handleRequest($_REQUEST);
        
        exit;
    }
}

